//
//  AlumnoViewController.m
//  rl11003SQLiteIOS
//
//  Created by Programacion para dispositivos moviles on 5/11/15.
//  Copyright (c) 2015 Oscar Rivas. All rights reserved.
//

#import "AlumnoViewController.h"
#import "controlBD.h"

@interface AlumnoViewController ()
{
    NSMutableArray *arrayAlumno;
    sqlite3 *alumnoBD;
    NSString *dbPathString;
}
@end

@implementation AlumnoViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    [[controlBD sharedInstance] crearOabrirBD];
    arrayAlumno = [[NSMutableArray alloc] init];
    [[self AlumnoTableView]setDelegate:self];
    [[self AlumnoTableView]setDataSource:self];
    
    // Do any additional setup after loading the view.
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    
    // Dispose of any resources that can be recreated.
}



- (IBAction)insertarAlumnoBoton:(id)sender {
    char *error;
    if (sqlite3_open([[controlBD sharedInstance].dbPath UTF8String], &alumnoBD) == SQLITE_OK) {
        NSString *insert_Stmt = [NSString stringWithFormat:@"insert into alumno (carnet,nombre,apellido,sexo,matganadas) values ('%s','%s','%s','%s','%d')",[self.carnetField.text UTF8String],[self.nombreField.text UTF8String],[self.apellidoField.text UTF8String],[self.sexoField.text UTF8String],[self.matGanadasField.text intValue]];
        
        const char *insert_stmt = [insert_Stmt UTF8String];
        
        if (sqlite3_exec(alumnoBD, insert_stmt, NULL, NULL, &error) == SQLITE_OK) {
            NSLog(@"Alumno insertado correctamente");
            Alumno *alumno = [[Alumno alloc]init];
            [alumno setCarnet:self.carnetField.text];
            [alumno setNombre:self.nombreField.text];
            [alumno setApellido:self.apellidoField.text];
            [alumno setSexo:self.sexoField.text];
            [alumno setMatganadas:[self.matGanadasField.text intValue]];
            [arrayAlumno addObject:alumno];
        }else{
            NSLog(@"Alumno no insertado");
        }
        sqlite3_close(alumnoBD);
    }
}


- (IBAction)actualizarAlumnoBoton:(id)sender {
    
    static sqlite3_stmt *statement = nil;
    if (sqlite3_open([[controlBD sharedInstance].dbPath UTF8String], &alumnoBD) == SQLITE_OK) {
        char *update_Stmt = "update alumno set nombre=?,apellido=?,sexo=?,matganadas=? where numalumno=?";
        if (sqlite3_prepare(alumnoBD, update_Stmt, -1, &statement, NULL) == SQLITE_OK) {
            sqlite3_bind_text(statement, 1, [self.nombreField.text UTF8String], -1, SQLITE_TRANSIENT);
            sqlite3_bind_text(statement, 2, [self.apellidoField.text UTF8String], -1, SQLITE_TRANSIENT);
            sqlite3_bind_text(statement, 3, [self.sexoField.text UTF8String], -1, SQLITE_TRANSIENT);
            sqlite3_bind_int(statement, 4, [self.matGanadasField.text intValue]);
            sqlite3_bind_int(statement, 5, [self.numAlumnoField.text intValue]);
            sqlite3_step(statement);
            sqlite3_finalize(statement);
            
            Alumno *alumno = [[Alumno alloc]init];
            [alumno setNumAlumno:[self.numAlumnoField.text intValue]];
            [alumno setCarnet:self.carnetField.text];
            [alumno setNombre:self.nombreField.text];
            [alumno setApellido:self.apellidoField.text];
            [alumno setSexo:self.sexoField.text];
            [alumno setMatganadas:[self.matGanadasField.text intValue]];
            [arrayAlumno addObject:alumno];
            
            NSLog(@"Alumno modificado");
        }else{
            NSLog(@"Alumno no modificado");
        }
        sqlite3_close(alumnoBD);
    }
}


- (IBAction)consultarAlumnoBoton:(id)sender {
    
    sqlite3_stmt *statement;
    if (sqlite3_open([[controlBD sharedInstance].dbPath UTF8String], &alumnoBD) == SQLITE_OK) {
        [arrayAlumno removeAllObjects];
        NSString *querySql = [NSString stringWithFormat:@"select * from alumno"];
        
        const char *querysql = [querySql UTF8String];
        
        if (sqlite3_prepare(alumnoBD, querysql, -1, &statement, NULL) == SQLITE_OK) {
            while (sqlite3_step(statement) == SQLITE_ROW) {
                NSString *numalumno1 = [[NSString alloc]initWithUTF8String:(const char *)sqlite3_column_text(statement, 0)];
                NSString *carnet1 = [[NSString alloc]initWithUTF8String:(const char *)sqlite3_column_text(statement, 1)];
                NSString *nombre1 = [[NSString alloc]initWithUTF8String:(const char *)sqlite3_column_text(statement, 2)];
                NSString *apellido1 = [[NSString alloc]initWithUTF8String:(const char *)sqlite3_column_text(statement, 3)];
                NSString *sexo1 = [[NSString alloc]initWithUTF8String:(const char *)sqlite3_column_text(statement, 4)];
                NSString *matganadas1 = [[NSString alloc]initWithUTF8String:(const char *)sqlite3_column_text(statement, 5)];
                
                Alumno *alumno = [[Alumno alloc]init];
                [alumno setNumAlumno:[numalumno1 intValue]];
                [alumno setCarnet:carnet1];
                [alumno setNombre:nombre1];
                [alumno setApellido:apellido1];
                [alumno setSexo:sexo1];
                [alumno setMatganadas:[matganadas1 intValue]];
                [arrayAlumno addObject:alumno];
            }
        }else{
            NSLog(@"Lista vacia");
        }
        sqlite3_close(alumnoBD);
    }
    [[self AlumnoTableView]reloadData];
}


- (IBAction)eliminarAlumnoBoton:(id)sender {
    
    [[self AlumnoTableView]setEditing:!self.AlumnoTableView.editing animated:YES];
    
}


-(void)deleteData:(NSString *)deleteQuery{
    char *error;
    if (sqlite3_open([[controlBD sharedInstance].dbPath UTF8String], &alumnoBD) == SQLITE_OK) {
        if (sqlite3_exec(alumnoBD, [deleteQuery UTF8String], NULL, NULL, &error) == SQLITE_OK) {
            NSLog(@"Alumno Eliminado");
        }else{
            NSLog(@"Alumno no Eliminado");
        }
        sqlite3_close(alumnoBD);
    }
}


-(void)tableView:(UITableView *)tableView commitEditingStyle:(UITableViewCellEditingStyle)editingStyle forRowAtIndexPath:(NSIndexPath *)indexPath{
    if (editingStyle == UITableViewCellEditingStyleDelete) {
        Alumno *alum = [arrayAlumno objectAtIndex:indexPath.row];
        [self deleteData:[NSString stringWithFormat:@"delete from alumno where carnet is '%s'",[alum.carnet UTF8String]]];
        [arrayAlumno removeObjectAtIndex:indexPath.row];
        [tableView deleteRowsAtIndexPaths:[NSArray arrayWithObject:indexPath] withRowAnimation:UITableViewRowAnimationFade];
    }
}


-(NSInteger)numberOfSectionsInTableView:(UITableView *)tableView{
    return 1;
}

-(NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section{
    return [arrayAlumno count];
}

-(UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    static NSString *cellIdentifier = @"Cell";
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:cellIdentifier];
    if (!cell) {
        cell = [[UITableViewCell alloc]initWithStyle:UITableViewCellStyleSubtitle reuseIdentifier:cellIdentifier];
    }
    Alumno *aAlumno = [arrayAlumno objectAtIndex:indexPath.row];
    cell.textLabel.text = aAlumno.carnet;
    cell.detailTextLabel.text = [NSString stringWithFormat:@"%@ %@",aAlumno.nombre,aAlumno.apellido];
    return cell;
}


-(void)touchesBegan:(NSSet *)touches withEvent:(UIEvent *)event{
    
    [super touchesBegan:touches withEvent:event];
    [[self numAlumnoField]resignFirstResponder];
    [[self carnetField]resignFirstResponder];
    [[self nombreField]resignFirstResponder];
    [[self apellidoField]resignFirstResponder];
    [[self sexoField]resignFirstResponder];
    [[self matGanadasField]resignFirstResponder];
    
}

@end
