//
//  MateriaViewController.m
//  rl11003SQLiteIOS
//
//  Created by Programacion para dispositivos moviles on 5/11/15.
//  Copyright (c) 2015 Oscar Rivas. All rights reserved.
//

#import "MateriaViewController.h"
#import "controlBD.h"

@interface MateriaViewController ()
{
    NSMutableArray *arrayMateria;
    sqlite3 *alumnoBD;
    NSString *dbPathString;
}
@end

@implementation MateriaViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    
    [[controlBD sharedInstance] crearOabrirBD];
    arrayMateria = [[NSMutableArray alloc] init];
    [[self materiasTableView]setDelegate:self];
    [[self materiasTableView]setDataSource:self];
    
    // Do any additional setup after loading the view.
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

/*
#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
}
*/

- (IBAction)InsertarMateriaBoton:(id)sender {
    
    char *error;
    if (sqlite3_open([[controlBD sharedInstance].dbPath UTF8String], &alumnoBD) == SQLITE_OK) {
        NSString *insert_Stmt = [NSString stringWithFormat:@"insert into materia (codmateria,nommateria,unidadesval) values ('%s','%s','%s')",[self.codMateriaField.text UTF8String],[self.nomMateriaField.text UTF8String],[self.unidadesValField.text UTF8String]];
        
        const char *insert_stmt = [insert_Stmt UTF8String];
        
        if (sqlite3_exec(alumnoBD, insert_stmt, NULL, NULL, &error) == SQLITE_OK) {
            NSLog(@"Materia insertada correctamente");
            Materia *materia = [[Materia alloc]init];
            [materia setCodMateria:self.codMateriaField.text];
            [materia setNomMateria:self.nomMateriaField.text];
            [materia setUnidadesVal:self.unidadesValField.text];
            [arrayMateria addObject:materia];
        }else{
            NSLog(@"Materia no insertada");
        }
        sqlite3_close(alumnoBD);
    }
    
}

- (IBAction)actualizarMateriaBoton:(id)sender {
    
    static sqlite3_stmt *statement = nil;
    if (sqlite3_open([[controlBD sharedInstance].dbPath UTF8String], &alumnoBD) == SQLITE_OK) {
        char *update_Stmt = "update materia set nommateria=?,unidadesval=? where nummateria=?";
        if (sqlite3_prepare(alumnoBD, update_Stmt, -1, &statement, NULL) == SQLITE_OK) {
            sqlite3_bind_text(statement, 1, [self.nomMateriaField.text UTF8String],-1,SQLITE_TRANSIENT);
            sqlite3_bind_text(statement, 2, [self.unidadesValField.text UTF8String],-1,SQLITE_TRANSIENT);
            sqlite3_bind_int(statement, 3, [self.numMateriaField.text intValue]);
            sqlite3_step(statement);
            sqlite3_finalize(statement);
            
            Materia *materia = [[Materia alloc]init];
            [materia setNumMateria:[self.numMateriaField.text intValue]];
            [materia setCodMateria:self.codMateriaField.text];
            [materia setNomMateria:self.nomMateriaField.text];
            [materia setUnidadesVal:self.unidadesValField.text];
            [arrayMateria addObject:materia];
            
            NSLog(@"Materia  modificada");
        }else{
            NSLog(@"Materia no modificada");
        }
        sqlite3_close(alumnoBD);
    }
    
}

- (IBAction)consultarMateriaBoton:(id)sender {
    
    sqlite3_stmt *statement;
    if (sqlite3_open([[controlBD sharedInstance].dbPath UTF8String], &alumnoBD) == SQLITE_OK) {
        [arrayMateria removeAllObjects];
        NSString *querySql = [NSString stringWithFormat:@"select * from materia"];
        
        const char *querysql = [querySql UTF8String];
        
        if (sqlite3_prepare(alumnoBD, querysql, -1, &statement, NULL) == SQLITE_OK) {
            while (sqlite3_step(statement) == SQLITE_ROW) {
                NSString *nummateria1 = [[NSString alloc]initWithUTF8String:(const char *)sqlite3_column_text(statement, 0)];
                NSString *codmateria1 = [[NSString alloc]initWithUTF8String:(const char *)sqlite3_column_text(statement, 1)];
                NSString *nommateria1 = [[NSString alloc]initWithUTF8String:(const char *)sqlite3_column_text(statement, 2)];
                NSString *unidadesval1 = [[NSString alloc]initWithUTF8String:(const char *)sqlite3_column_text(statement, 3)];
                
                Materia *materia = [[Materia alloc]init];
                [materia setNumMateria:[nummateria1 intValue]];
                [materia setCodMateria:codmateria1];
                [materia setNomMateria:nommateria1];
                [materia setUnidadesVal:unidadesval1];
                [arrayMateria addObject:materia];

            }
        }else{
            NSLog(@"Lista vacia");
        }
        sqlite3_close(alumnoBD);
    }
    [[self materiasTableView]reloadData];
    
}

- (IBAction)eliminarMateriaBoton:(id)sender {
    
    [[self materiasTableView]setEditing:!self.materiasTableView.editing animated:YES];
    
}

-(void)deleteData:(NSString *)deleteQuery{
    char *error;
    if (sqlite3_open([[controlBD sharedInstance].dbPath UTF8String], &alumnoBD) == SQLITE_OK) {
        if (sqlite3_exec(alumnoBD, [deleteQuery UTF8String], NULL, NULL, &error) == SQLITE_OK) {
            NSLog(@"Materia no Eliminada");
        }else{
            NSLog(@"Materia no Eliminada");
        }
        sqlite3_close(alumnoBD);
    }
}


-(void)tableView:(UITableView *)tableView commitEditingStyle:(UITableViewCellEditingStyle)editingStyle forRowAtIndexPath:(NSIndexPath *)indexPath{
    if (editingStyle == UITableViewCellEditingStyleDelete) {
        Materia *materia = [arrayMateria objectAtIndex:indexPath.row];
        [self deleteData:[NSString stringWithFormat:@"delete from materia where codmateria is '%s'",[materia.codMateria UTF8String]]];
        [arrayMateria removeObjectAtIndex:indexPath.row];
        [tableView deleteRowsAtIndexPaths:[NSArray arrayWithObject:indexPath] withRowAnimation:UITableViewRowAnimationFade];
    }
}


-(NSInteger)numberOfSectionsInTableView:(UITableView *)tableView{
    return 1;
}

-(NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section{
    return [arrayMateria count];
}

-(UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    static NSString *cellIdentifier = @"Cell";
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:cellIdentifier];
    if (!cell) {
        cell = [[UITableViewCell alloc]initWithStyle:UITableViewCellStyleSubtitle reuseIdentifier:cellIdentifier];
    }
    Materia *materia = [arrayMateria objectAtIndex:indexPath.row];
    cell.textLabel.text = materia.codMateria;
    cell.detailTextLabel.text = [NSString stringWithFormat:@"%@ %@",materia.nomMateria,materia.unidadesVal];
    return cell;
}


-(void)touchesBegan:(NSSet *)touches withEvent:(UIEvent *)event{
    
    [super touchesBegan:touches withEvent:event];
    [[self numMateriaField]resignFirstResponder];
    [[self codMateriaField]resignFirstResponder];
    [[self nomMateriaField]resignFirstResponder];
    [[self unidadesValField]resignFirstResponder];
    
}

@end
