//
//  NotaViewController.m
//  rl11003SQLiteIOS
//
//  Created by Programacion para dispositivos moviles on 5/11/15.
//  Copyright (c) 2015 Oscar Rivas. All rights reserved.
//

#import "NotaViewController.h"
#import "controlBD.h"

@interface NotaViewController ()
{
    NSMutableArray *arrayNota;
    sqlite3 *alumnoBD;
    NSString *dbPathString;
}
@end

@implementation NotaViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    
    [[controlBD sharedInstance] crearOabrirBD];
    arrayNota = [[NSMutableArray alloc] init];
    [[self notasTableView]setDelegate:self];
    [[self notasTableView]setDataSource:self];
    
    // Do any additional setup after loading the view.
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

/*
#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
}
*/

- (IBAction)insertarNotaBoton:(id)sender {
    
    char *error;
    if (sqlite3_open([[controlBD sharedInstance].dbPath UTF8String], &alumnoBD) == SQLITE_OK) {
        NSString *insert_Stmt = [NSString stringWithFormat:@"insert into nota (codmateria,carnet,ciclo,notafinal) values ('%s','%s','%s','%f')",[self.codMateriaField.text UTF8String],[self.carnetField.text UTF8String],[self.cicloField.text UTF8String],[self.notaFinalField.text floatValue]];
        
        const char *insert_stmt = [insert_Stmt UTF8String];
        
        if (sqlite3_exec(alumnoBD, insert_stmt, NULL, NULL, &error) == SQLITE_OK) {
            NSLog(@"Nota insertada correctamente");
            Nota *nota = [[Nota alloc]init];
            //[nota setNumNota:[self.notaFinalField.text intValue]];
            [nota setCodMateria:self.codMateriaField.text];
            [nota setCarnet:self.carnetField.text];
            [nota setCiclo:self.cicloField.text];
            [nota setNotaFinal:[self.notaFinalField.text floatValue]];
            [arrayNota addObject:nota];
        }else{
            NSLog(@"Nota no insertada");
        }
        sqlite3_close(alumnoBD);
    }
    
}

- (IBAction)actualizarNotaBoton:(id)sender {
    
    static sqlite3_stmt *statement = nil;
    if (sqlite3_open([[controlBD sharedInstance].dbPath UTF8String], &alumnoBD) == SQLITE_OK) {
        char *update_Stmt = "update nota set notafinal=? where numnota=?";
        if (sqlite3_prepare(alumnoBD, update_Stmt, -1, &statement, NULL) == SQLITE_OK) {
            sqlite3_bind_double(statement, 1, [self.notaFinalField.text floatValue]);
            sqlite3_bind_int(statement, 2, [self.numNotaField.text intValue]);
            sqlite3_step(statement);
            sqlite3_finalize(statement);
            
            Nota *nota = [[Nota alloc]init];
            [nota setNumNota:[self.notaFinalField.text intValue]];
            [nota setCodMateria:self.codMateriaField.text];
            [nota setCarnet:self.carnetField.text];
            [nota setCiclo:self.cicloField.text];
            [nota setNotaFinal:[self.notaFinalField.text floatValue]];
            [arrayNota addObject:nota];
            
            NSLog(@"Nota no modificada");
        }else{
            NSLog(@"Nota no modificada");
        }
        sqlite3_close(alumnoBD);
    }
    
}

- (IBAction)consultarNotaBoton:(id)sender {
    
    sqlite3_stmt *statement;
    if (sqlite3_open([[controlBD sharedInstance].dbPath UTF8String], &alumnoBD) == SQLITE_OK) {
        [arrayNota removeAllObjects];
        NSString *querySql = [NSString stringWithFormat:@"select * from nota"];
        
        const char *querysql = [querySql UTF8String];
        
        if (sqlite3_prepare(alumnoBD, querysql, -1, &statement, NULL) == SQLITE_OK) {
            while (sqlite3_step(statement) == SQLITE_ROW) {
                NSString *numnota1 = [[NSString alloc]initWithUTF8String:(const char *)sqlite3_column_text(statement, 0)];
                NSString *codmateria1 = [[NSString alloc]initWithUTF8String:(const char *)sqlite3_column_text(statement, 1)];
                NSString *carnet1 = [[NSString alloc]initWithUTF8String:(const char *)sqlite3_column_text(statement, 2)];
                NSString *ciclo1 = [[NSString alloc]initWithUTF8String:(const char *)sqlite3_column_text(statement, 3)];
                NSString *notafinal1 = [[NSString alloc]initWithUTF8String:(const char *)sqlite3_column_text(statement, 4)];
                
                Nota *nota = [[Nota alloc]init];
                [nota setNumNota:[numnota1 intValue]];
                [nota setCodMateria:codmateria1];
                [nota setCarnet:carnet1];
                [nota setCiclo:ciclo1];
                [nota setNotaFinal:[notafinal1 floatValue]];
                [arrayNota addObject:nota];
            }
        }else{
            NSLog(@"Lista vacia");
        }
        sqlite3_close(alumnoBD);
    }
    [[self notasTableView]reloadData];
    
}

- (IBAction)eliminarNotaBoton:(id)sender {
    
    [[self notasTableView]setEditing:!self.notasTableView.editing animated:YES];
    
}



-(void)deleteData:(NSString *)deleteQuery{
    char *error;
    if (sqlite3_open([[controlBD sharedInstance].dbPath UTF8String], &alumnoBD) == SQLITE_OK) {
        if (sqlite3_exec(alumnoBD, [deleteQuery UTF8String], NULL, NULL, &error) == SQLITE_OK) {
            NSLog(@"Nota Eliminada");
        }else{
            NSLog(@"Nota no Eliminada");
        }
        sqlite3_close(alumnoBD);
    }
}


-(void)tableView:(UITableView *)tableView commitEditingStyle:(UITableViewCellEditingStyle)editingStyle forRowAtIndexPath:(NSIndexPath *)indexPath{
    if (editingStyle == UITableViewCellEditingStyleDelete) {
        Nota *nota = [arrayNota objectAtIndex:indexPath.row];
        [self deleteData:[NSString stringWithFormat:@"delete from nota where carnet is '%s' and codmateria is '%s' and ciclo is '%s'",[nota.carnet UTF8String],[nota.codMateria UTF8String],[nota.ciclo UTF8String]]];
        [arrayNota removeObjectAtIndex:indexPath.row];
        [tableView deleteRowsAtIndexPaths:[NSArray arrayWithObject:indexPath] withRowAnimation:UITableViewRowAnimationFade];
    }
}


-(NSInteger)numberOfSectionsInTableView:(UITableView *)tableView{
    return 1;
}

-(NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section{
    return [arrayNota count];
}

-(UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    
    static NSString *cellIdentifier = @"Cell";
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:cellIdentifier];
    if (!cell) {
        cell = [[UITableViewCell alloc]initWithStyle:UITableViewCellStyleSubtitle reuseIdentifier:cellIdentifier];
    }
    Nota *nota = [arrayNota objectAtIndex:indexPath.row];
    cell.textLabel.text = [NSString stringWithFormat:@"%f", nota.notaFinal];
    cell.detailTextLabel.text = [NSString stringWithFormat:@"%@ %@",nota.carnet,nota.codMateria];
    return cell;
    
}


-(void)touchesBegan:(NSSet *)touches withEvent:(UIEvent *)event{
    
    [super touchesBegan:touches withEvent:event];
    [[self numNotaField]resignFirstResponder];
    [[self codMateriaField]resignFirstResponder];
    [[self carnetField]resignFirstResponder];
    [[self cicloField]resignFirstResponder];
    [[self notaFinalField]resignFirstResponder];
    
}


@end
