//
//  controlBD.m
//  rl11003SQLiteIOS
//
//  Created by Programacion para dispositivos moviles on 5/31/15.
//  Copyright (c) 2018. PDM115 All rights reserved.
//

#import "controlBD.h"

@interface controlBD()
{
    sqlite3 *alumnoBD;
    NSString *dbPathString;
}
@end

@implementation controlBD

+(controlBD *) sharedInstance{
    static controlBD *myInstance=nil;
    // chect to see if an instance already exists
    if (nil == myInstance) {
        myInstance = [[[self class] alloc] init];
    }
    // return the instance of this class
    return myInstance;
}

-(void) crearOabrirBD
{
    NSArray *path = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
    NSString *docPath = [path objectAtIndex:0];
    dbPathString = [docPath stringByAppendingPathComponent:@"carnet1.db"];
    char *error;
    NSFileManager *fileManager = [NSFileManager defaultManager];
    if (![fileManager fileExistsAtPath:dbPathString]) {
        const char *dbPath = [dbPathString UTF8String];
        // crear la base de datos
        if (sqlite3_open(dbPath, &alumnoBD) == SQLITE_OK) {
            NSString *foreign = @"PRAGMA foreign_keys = ON";
            const char *foreign1 = [foreign UTF8String];
            if (sqlite3_exec(alumnoBD, foreign1, NULL, NULL, &error) != SQLITE_OK) {
                NSLog(@"failed to set the foreign_key pragma");
                return;
            }
            const char *sql_stmt = "create table alumno(numalumno integer not null primary key autoincrement, carnet varchar(7) not null unique, nombre varchar(30) not null, apellido varchar(30) not null, sexo varchar(1) not null, matganadas integer);";
            
            sqlite3_exec(alumnoBD, sql_stmt, NULL, NULL, &error);
            sql_stmt = "create table materia(nummateria integer not null primary key autoincrement, codmateria varchar(6) not null unique, nommateria varchar(30) not null, unidadesval varchar(1) not null);";
            sqlite3_exec(alumnoBD, sql_stmt, NULL, NULL, &error);
            sql_stmt = "create table nota(numnota integer not null primary key autoincrement, codmateria varchar(6) not null, carnet varchar(7) not null, ciclo varchar(5) not null, notafinal float integer, foreign key (carnet) references alumno (carnet) on delete restrict on update restrict, foreign key (codmateria) references materia (codmateria) on delete restrict on update restrict);";
            sqlite3_exec(alumnoBD, sql_stmt, NULL, NULL, &error);
            sqlite3_close(alumnoBD);
            _dbPath = dbPathString;
            return;
        }
    }
    const char *dbPath = [dbPathString UTF8String];
    //crear la base de datos
    if (sqlite3_open(dbPath, &alumnoBD) == SQLITE_OK) {
        _dbPath = dbPathString;
    }
}

@end
